<?php

namespace Teknisa\DF\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;

class NotafiscalOrigem extends \Teknisa\DF\Controllers\TeknisaCrud
{
    protected $dataSourceName = 'notafiscal_origem';
    protected $environment;
    protected $parameterBagColumns = array(
        'P_FILIAL',
        'P_CDFILIRECE',
        'P_CDFILIEMIT',
        'P_IDTPIJURNF',
        'P_NRINSJURNF',
        'P_NOTAFISC',
        'P_CDTIPOOPSA',
        'P_SERIE',
        'P_CDTIPOOPEN'
    );

    public function __construct($crudService, ParameterBag $parameterBag, $environment) {
        parent::__construct($crudService, $parameterBag);
        $this->environment = $environment;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $filterCriteria = $request->getFilterCriteria();
            $filial = false;
            foreach($filterCriteria->getConditions() as $filter) {
                if($filter["columnName"] == 'P_FILIAL') $filial = true;
            }
            if($filial === false) {
                $filterCriteria->addCondition('P_FILIAL', $this->environment->getCdFilial());
            }
            parent::find($request, $response);
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }
}