<?php

namespace Teknisa\DF\Modules\Saida\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

use Teknisa\Libs\Util\Environment;
    
class Dfs88000ConhecimentoTransporteEletronicoFactory {
    
    private $entityManager;
    private $connection;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }
    
    public function getDefaultCte($cdEmpresa, $cdInscesta) {
        $sql = "SELECT IE.IDTPIJURIEST AS IDTPIJUREMIT,
                       IE.NRINSJURIEST AS NRINSJUREMIT,
                       E.NMRAZSOCEMPR AS NMRAZSOCEMIEST,
                       IE.NMREPRINSEST AS NMREPRINSESTEMIT,
                       IE.CDINSCESTA,
                       IE.CDINSCESTA AS NRINSESTEMIT,
                       IE.NRINSJURIEST,
                       E.NMEMPRESA AS NMFANTEMIT,
                       IE.NRTELEIEST AS NRTELEEMIT,
                       E.DSEMAILEMPRESA AS DSEMAILEMIT,
                       IE.DSENDEIEST AS DSENDEEMIT,
                       IE.DSCOMPENDIES AS DSCOMPENDEMIT,
                       IE.NRCEPIEST AS NRCEPEMIT,
                       IE.CDPAIS AS CDPAISEMIT,
                       P.NMPAIS AS NMPAISEMIT,
                       P.CDPAISBACEN AS CDPAISBACENEMIT,
                       IE.SGESTADO AS SGESTADOEMIT,
                       ES.NMESTADO AS NMESTADOEMIT,
                       ES.CDESTADOIBGE AS CDESTADOIBGEEMIT,
                       IE.CDMUNICIPIO AS CDMUNICIPIOEMIT,
                       M.NMMUNICIPIO AS NMMUNICIPIOEMIT,
                       M.CDMUNICIBGE AS CDMUNICIBGEEMIT,
                       IE.NMBAIRIEST AS NMBAIREMIT,
                       E.CDEMPRESA,
                       IE.NRSERIECERTIFIC, 
                       IE.IDPRESTSERVTRANSP,
                       IE.IDTPIMPRESDACTE AS IDFORMAIMPDACTE,
                       IE.IDTPAMBIENTECTE AS IDAMBIENTECTE,
                       NVL(IE.CDMODDOCFISCCTE, '57') AS CDMODDOCFISC,
                       IE.CDSERIECTE,
                       IE.CDPAIS AS CDPAISINISERV,
                       P.NMPAIS AS NMPAISINISERV,
                       IE.CDPAIS AS CDPAISFIMSERV,
                       P.NMPAIS AS NMPAISFIMSERV,
                       'P' AS IDSTATUSCTE,
                       'Pendente' AS DSSTATUSCTE,
                       'P' AS IDEMAILCTE,
                       'Pendente' AS DSEMAILCTE,
                       SYSDATE AS DTEMISSAO
                  FROM INSCRESTAD IE, EMPRESA E, PAIS P, ESTADO ES, MUNICIPIO M 
                 WHERE IE.CDEMPRESA = E.CDEMPRESA
                   AND IE.CDPAIS = P.CDPAIS
                   AND IE.CDPAIS = ES.CDPAIS
                   AND IE.SGESTADO = ES.SGESTADO
                   AND IE.CDPAIS = M.CDPAIS
                   AND IE.SGESTADO = M.SGESTADO
                   AND IE.CDMUNICIPIO = M.CDMUNICIPIO
                   AND IE.CDEMPRESA = :P_CDEMPRESA
                   AND (IE.CDINSCESTA = :P_CDINSCESTA
                        OR :P_CDINSCESTA IS NULL)";
       
       $params = array(
            "P_CDEMPRESA" => $cdEmpresa,
            "P_CDINSCESTA" => $cdInscesta
        );
        
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetch();
    }
    
    public function getDefaultFilterCte($cdfilial) {
        $sql = "SELECT E.CDEMPRESA, E.NMEMPRESA, E.NMRAZSOCEMPR, I.NRINSJURIEST, I.CDINSCESTA, I.NMREPRINSEST, F.NRORG FROM EMPRESA E, FILIAL F, INSCRESTAD I
                WHERE F.CDEMPRESA = E.CDEMPRESA
                AND   F.CDFILIAL  = :P_CDFILIAL
                AND   E.NRINSJUREMPR = I.NRINSJURIEST";
        
        $params = array(
            "P_CDFILIAL"        => $cdfilial
        );

        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
		return $std->fetch();  
    }
    
}